
'This example shows some of the functionality available in scanning mode. Although
'  very little code is required to connect and scan, this example's code is rather
'  length only to show some of the additional functionality available for setting up
'  the scan as well as checking the status of the scan during the run. Please visit 
'  our website to view the entire API for scan and other functionality:
'       http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/M30x_SP_X/Shared/ArchiveContents/_HTML_docs/FunctionUsage/FuncUse.htm
'  the same link condensed for easy copy:
'       http://tinyurl.com/62qp6a
'Using CTRL + "left mouse button" will load the page here for you.
'Links from the main page: http://www.lawsonlabs.com to the developer's section will provide additional
'  links for other software language examples as well as answers to some frequently asked questions and
'  other reference material.

Public Class Form1
    Public usDevID As Short, fScanning As Byte, sModelNum As Short
    Public lRawCountArray(8) As Integer
    Public myMsgs As TextBox
    Public Const USE_SCAN_DATA_ARRAY As Short = 2
    Public Const MULTI_CHAN_SCAN As Short = 2
    Public Const GS_SCAN_COMPLETED As Short = &H8S
    Declare Function EX_Connect Lib "LL_USB2k.dll" (ByRef usDevID As Short) As Byte
    Declare Function EX_SendDigout Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByVal bDigOut As Byte) As Byte
    Declare Function EX_GetDigin Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByRef bDigOut As Byte) As Byte
    Declare Function EX_SetMultiChanScanChans Lib "LL_USB2k.DLL" (ByVal DevID As Short, ByVal bChanCnt As Byte) As Byte
    Declare Function EX_Run Lib "LL_USB2k.DLL" (ByVal DevID As Short) As Byte
    Declare Function EX_Stop Lib "LL_USB2k.DLL" (ByVal DevID As Short) As Byte
    Declare Function EX_StopComplete Lib "LL_USB2k.DLL" (ByVal DevID As Short) As Byte
    Declare Function EX_SetScanType Lib "LL_USB2k.DLL" (ByVal DevID As Short, ByVal bScanType As Byte) As Byte
    Declare Function EX_CheckScanStatus Lib "LL_USB2k.DLL" (ByVal pDevID As Short, ByRef puiNumScansRemainingInBuff As Integer, ByRef pfStillScanning As Byte, ByRef puiStatusCode As Integer) As Byte
    Declare Function EX_GetScanDataInt Lib "LL_USB2k.DLL" (ByVal DevID As Short, ByRef piDataBuff As Integer, ByVal uiNumScansToReturn As Integer, ByVal fGetAllRequested As Byte, ByRef puiNumScansReturned As Integer, ByRef puiNumScansRemainingInBuff As Integer, ByRef pfStillScanning As Byte, ByRef puiTotalBuffSize As Integer, ByRef puiErrCode As Integer) As Byte
    Declare Function EX_SetDataLogOptions Lib "LL_USB2k.DLL" (ByVal usDevID As Short, ByVal uiDataLogMethod As Integer, ByVal uiLogFileMaxSize As Integer, ByVal uiMisc As Integer) As Byte
    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Dim bRetVal As Byte
        PanelWait.Visible = True : PanelWait.Location = New Point(7, 9) : PanelWait.Update()
        Label2.Text = "connecting" : Label2.Update()
        Msgs.Text = "Please wait !" & vbCrLf : Msgs.Update()
        bRetVal = EX_Connect(usDevID)
        If bRetVal = 0 Then
            Msgs.Text = "Failed connecting" & vbCrLf : Msgs.Update()
            txtDevID.Text = "" : btnDigOut.Enabled = False : btnDigIn.Enabled = False : btnScan.Enabled = False
        Else
            If ((usDevID > 100) And (usDevID < 5000)) Then sModelNum = 301
            Msgs.Text = "Success connecting" & vbCrLf
            txtDevID.Text = usDevID : btnDigOut.Enabled = True : btnDigIn.Enabled = True : btnScan.Enabled = True
            'btnConnect.Enabled = False 'before another call to this function, DLL_ReleaseDeviceFromIDList, documented
            'elsewhere would need to be called
        End If
        PanelWait.Visible = False
    End Sub
    Private Sub btnDigOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigOut.Click
        txtRet.Text = CByte(EX_SendDigout(usDevID, CByte(txtDigout.Text)))
    End Sub
    Private Sub btnDigIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigIn.Click
        Dim bDigin As Byte
        txtRet.Text = CByte(EX_GetDigin(usDevID, bDigin))
        txtDigIn.Text = bDigin
    End Sub
    Private Sub btnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScan.Click
        Dim bRetVal As Byte
        If fScanning = 1 Then
            PanelWait.Visible = True : PanelWait.Update()
            Label2.Text = "stopping scan" : Label2.Update()
            Msgs.Text = Msgs.Text & "stopping scan" & vbCrLf : Msgs.Update()
            bRetVal = EX_Stop(usDevID) 'this stops the DLL's data-taking thread
            bRetVal = EX_StopComplete(usDevID) 'this stops all scanning related processes
            Msgs.Text = Msgs.Text & "scan stopped" & vbCrLf : Msgs.Update()
            fScanning = 0 : btnConnect.Enabled = True : btnExit.Enabled = True
            btnScan.Text = "Start Scan"
            PanelWait.Visible = False
            Exit Sub
        End If

        PanelWait.Visible = True : PanelWait.Update()
        Label2.Text = "starting scan" : Label2.Update()

        Dim uiStatusCode, puiTotalBuffSize, uiNumScansRemaining, uiNumScansReturned, uiMisc As Integer
        Dim fGetAllRequested, pfStillScanning As Byte, dblVoltsTemp As Double
        fGetAllRequested = 0
        bRetVal = EX_SetDataLogOptions(usDevID, USE_SCAN_DATA_ARRAY, 0, uiMisc)
        If bRetVal = 0 Then
            Msgs.Text = Msgs.Text & "Failed EX_SetDataLogOptions" & vbCrLf : Msgs.Update()
            PanelWait.Visible = False : PanelWait.Update()
            Exit Sub
        End If
        bRetVal = EX_SetScanType(usDevID, MULTI_CHAN_SCAN)
        If bRetVal = 0 Then
            Msgs.Text = Msgs.Text & "Failed EX_SetScanType" & vbCrLf : Msgs.Update()
            PanelWait.Visible = False : PanelWait.Update()
            Exit Sub
        End If
        If sModelNum = 301 Then : bRetVal = EX_SetMultiChanScanChans(usDevID, 4) 'the model-301 only has 4 analog channels
        Else : bRetVal = EX_SetMultiChanScanChans(usDevID, 8) : End If 'the model-302 has 8 analog channels

        If bRetVal = 0 Then
            Msgs.Text = Msgs.Text & "Failed EX_SetMultiChanScanChans" & vbCrLf : Msgs.Update()
            PanelWait.Visible = False : PanelWait.Update()
            Exit Sub
        End If
        bRetVal = EX_Run(usDevID)
        If bRetVal = 0 Then
            Msgs.Text = Msgs.Text & "Failed EX_Run" & vbCrLf : Msgs.Update()
            PanelWait.Visible = False : PanelWait.Update()
            Exit Sub
        End If
        Msgs.Text = Msgs.Text & "Scan Started" & vbCrLf : Msgs.Update()
        fScanning = 1
        btnScan.Text = "Stop Scan" : btnScan.Update()
        Dim bTempCnt As Byte : bTempCnt = 0
        PanelWait.Visible = False : PanelWait.Update()
        While (True)
            bRetVal = EX_CheckScanStatus(usDevID, uiNumScansRemaining, pfStillScanning, uiStatusCode)
            txtStat.Text = Hex(uiStatusCode)
            If uiNumScansRemaining > 0 Then
                bRetVal = EX_GetScanDataInt(usDevID, lRawCountArray(0), 1, fGetAllRequested, uiNumScansReturned, uiNumScansRemaining, pfStillScanning, puiTotalBuffSize, uiStatusCode)
                If bRetVal = 0 Then
                    Msgs.Text = Msgs.Text & "Failed EX_GetScanDataInt" & vbCrLf : Msgs.Update()
                    btnScan.Focus() : System.Windows.Forms.Application.DoEvents() : btnScan_Click(btnScan, New System.EventArgs)
                    GoTo DoneScan
                End If
                If sModelNum = 301 Then 'the model-301 only has 4 analog channels
                    dblVoltsTemp = (lRawCountArray(0) - 8388608) * 0.00000059604645 : lstVolts.Items.RemoveAt(0)
                    If dblVoltsTemp < 0.0 Then lstVolts.Items.Insert(0, Format(Math.Abs(dblVoltsTemp), "-#.000000")) Else lstVolts.Items.Insert(0, Format(dblVoltsTemp, " #.000000"))
                    dblVoltsTemp = (lRawCountArray(1) - 8388608) * 0.00000059604645 : lstVolts.Items.RemoveAt(1)
                    If dblVoltsTemp < 0.0 Then lstVolts.Items.Insert(1, Format(Math.Abs(dblVoltsTemp), "-#.000000")) Else lstVolts.Items.Insert(1, Format(dblVoltsTemp, " #.000000"))
                    dblVoltsTemp = (lRawCountArray(2) - 8388608) * 0.00000059604645 : lstVolts.Items.RemoveAt(6)
                    If dblVoltsTemp < 0.0 Then lstVolts.Items.Insert(6, Format(Math.Abs(dblVoltsTemp), "-#.000000")) Else lstVolts.Items.Insert(6, Format(dblVoltsTemp, " #.000000"))
                    dblVoltsTemp = (lRawCountArray(3) - 8388608) * 0.00000059604645 : lstVolts.Items.RemoveAt(7)
                    If dblVoltsTemp < 0.0 Then lstVolts.Items.Insert(7, Format(Math.Abs(dblVoltsTemp), "-#.000000")) Else lstVolts.Items.Insert(7, Format(dblVoltsTemp, " #.000000"))
                Else
                    For bTempCnt = 0 To 7 'the model-302 has 8 analog channels
                        dblVoltsTemp = (lRawCountArray(bTempCnt) - 8388608) * 0.00000059604645
                        lstVolts.Items.RemoveAt(bTempCnt)
                        If dblVoltsTemp < 0.0 Then
                            lstVolts.Items.Insert(bTempCnt, Format(Math.Abs(dblVoltsTemp), "-#.0000000"))
                        Else
                            lstVolts.Items.Insert(bTempCnt, Format(dblVoltsTemp, " #.0000000"))
                        End If
                    Next bTempCnt
                End If
            End If

            If (uiStatusCode And GS_SCAN_COMPLETED) > 0 Then
                btnScan.Focus() : System.Windows.Forms.Application.DoEvents() : btnScan_Click(btnScan, New System.EventArgs)
                GoTo DoneScan
            End If
            If fScanning = 0 Then GoTo DoneScan
            System.Windows.Forms.Application.DoEvents()
        End While

DoneScan:
        fScanning = 0 : btnConnect.Enabled = True : btnExit.Enabled = True
        btnScan.Text = "Start Scan"
    End Sub
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Msgs.Text = ""
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Form1.ActiveForm.Close()
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        usDevID = 0
    End Sub
End Class
